package bug;

import java.io.FileInputStream;
import java.io.FileOutputStream;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.poifs.filesystem.POIFSFileSystem;

public class Bug_StyleVsHeight {

	public static void main(String[] args) throws Exception {
		POIFSFileSystem fs;
		HSSFWorkbook wb;
		HSSFSheet sheet;
		HSSFRow row;
		HSSFCell cell;
		HSSFFont font;
		HSSFCellStyle style;
		
		FileOutputStream out;

		// clone without autofilter
		//fs = new POIFSFileSystem(new FileInputStream("bug_shiftrows_and_ranges.xls"));
		
		//wb = new HSSFWorkbook(fs);
		wb = new HSSFWorkbook();
		
		sheet = wb.createSheet("new sheet");
		row = sheet.createRow(0);
		
		System.out.println("newly created row height "+row.getHeight()+" in points "+row.getHeightInPoints());
		
		cell = row.createCell(0);
		cell.setCellValue("Sample Text");
		
		font = wb.createFont();
		font.setFontName("Arial");
		font.setFontHeightInPoints((short)30);
		
		style = wb.createCellStyle();
		style.setFont(font);
		
		cell.setCellStyle(style);
		
		System.out.println("row height after cell and style: "+row.getHeight()+" in points "+row.getHeightInPoints());
		System.out.println("(see the excel, row height is matching font height)");
		
		out = new FileOutputStream("bug_style_vs_height_OUT.xls");
		wb.write(out);
		out.close();

		fs = new POIFSFileSystem(new FileInputStream("bug_style_vs_height_OUT.xls"));		
		wb = new HSSFWorkbook(fs);
		sheet = wb.getSheetAt(0);
		row = sheet.getRow(0);
		
		System.out.println("row height after reading excel back: "+row.getHeight()+" in points "+row.getHeightInPoints());
		System.out.println("(still)");

		fs = new POIFSFileSystem(new FileInputStream("bug_style_vs_height_OUT_saved_from_excel.xls"));		
		wb = new HSSFWorkbook(fs);
		sheet = wb.getSheetAt(0);
		row = sheet.getRow(0);
		
		System.out.println("row height after Excel save: "+row.getHeight()+" in points "+row.getHeightInPoints());
		System.out.println("(this is what I expected at first place)");

		
		System.out.println("done");
		
	}
	
}
	